require "import"
import "android.content.Intent"
import "android.graphics.Bitmap"
import "android.net.Uri"
import "java.io.*"
import "com.androlua.*"

app_pkg = "com.bemyeyes.bemyeyes"
store_url = "market://details?id="

-- Função para gerar um nome de arquivo único
function generateImageName()
    local timestamp = os.time()
    local randomNum = math.random(1000, 9999)
    return string.format("print_%d_%d.jpg", timestamp, randomNum)
end

-- Função para garantir que a pasta exista
function ensureDirectoryExists(directoryPath)
    local dir = File(directoryPath)
    if not dir.exists() then
        dir.mkdirs()
    end
end

if this.getPackageManager().getLaunchIntentForPackage(app_pkg) then
    this.getScreenShot({
        onScreenCaptureDone = function(A0_4)
            local directoryPath = "/sdcard/bemyeyes/prints"
            ensureDirectoryExists(directoryPath)
            
            local imageName = generateImageName()
            local imagePath = directoryPath .. "/" .. imageName
            A0_4.compress(Bitmap.CompressFormat.PNG, 90, FileOutputStream(File(imagePath)))

            -- Introduz um atraso antes de continuar o resto do código
            task(500, function()
                -- Copia o nome da imagem para a área de transferência
                service.copy(imageName)

                -- Cria a intent para enviar a imagem
                local intent = Intent(Intent.ACTION_SEND)
                intent.setType("image/*")
                intent.setPackage(app_pkg)
                intent.putExtra(Intent.EXTRA_STREAM, this.getUriForFile(File(imagePath)))
                this.startActivity(intent)
            end)
        end
    })
else
    this.startActivity(Intent(Intent.ACTION_VIEW).setData(Uri.parse(store_url .. app_pkg)))
end